<script setup lang="ts">
import { useCustomerStore } from '@/stores/customer'
import { useLoadingStore } from '@/stores/loading'
import { ref, nextTick, onMounted } from 'vue'
import type { VForm } from 'vuetify/components'
const customerStore = useCustomerStore()
const loadingStore = useLoadingStore()

const refForm = ref<VForm | null>(null)
onMounted(async () => {
  await customerStore.getCustomers()
})
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await customerStore.saveCustomer2()
  customerStore.closeDialog()
}
</script>

<template>
  <v-dialog v-model="customerStore.dialog" persistent width="1024">
    <v-card>
      <v-card-title>
        <span class="text-h5">Customer Profile</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="customerStore.form" @submit.prevent="customerStore.onSubmit">
          <v-container>
            <v-row>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="customerStore.editedCustomer.name"
                  :readonly="loadingStore.isLoading"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Full name"
                >
                </v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="customerStore.editedCustomer.tel"
                  :readonly="loadingStore.isLoading"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Tel"
                >
                </v-text-field>
              </v-col>
              <v-col cols="12" sm="4">
                <v-combobox
                  label="Gender"
                  v-model="customerStore.editedCustomer.gender"
                  :items="['male', 'female', 'others']"
                >
                </v-combobox>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small>*indicates required field</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="customerStore.closeDialog()">
          Close
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
